0a1,4
> /*
> static char sccsid[] = "@(#)74  1.1  src/com/ibm/cim/CIMFlavor.java, cimom, ICAT1, ICAT1_1.0.0.7 10/10/02 14:42:10";
> */
> 
61d64
< package org.snia.wbem.cim;
62a66,68
> package com.ibm.cim;
> 
> 
66,100c72
< public class CIMFlavor extends Object implements Serializable {
<     public static final int ENABLEOVERRIDE=1;	// overridable
<     public static final int DISABLEOVERRIDE=2;	// cannot be overriden
<     public static final int RESTRICTED=3;	// applies only to the declaring class
<     public static final int TOSUBCLASS=4;	// qualifier is inherited
<     public static final int TRANSLATE=5;	// qualifier can be specified in multiple locales
<     private static final int LASTVALUE=6;
<     private static CIMFlavor[] predefined= new CIMFlavor[10];
<     private int flavor=0;
<     
<     static {
< 	int cnt=0;
< 	
< 	predefined[cnt++]=new CIMFlavor(ENABLEOVERRIDE);
< 	predefined[cnt++]=new CIMFlavor(DISABLEOVERRIDE);
< 	predefined[cnt++]=new CIMFlavor(RESTRICTED);
< 	predefined[cnt++]=new CIMFlavor(TOSUBCLASS);
< 	predefined[cnt++]=new CIMFlavor(TRANSLATE);
<     }
<     
<     private boolean validScope(int iflavor) {
< 	//
< 	// NOTE: has implicit knowledge of flavor values!
< 	//
< 	return(iflavor>=ENABLEOVERRIDE && iflavor<LASTVALUE);
<     }
<     
<     // CIMFlavor 
<     // 
<     public CIMFlavor(int iflavor) {
< 	//
< 	// Value only gets set if its valid
< 	//
< 	if ( !validScope(iflavor) )
< 	    throw new InstantiationError("Not a valid flavor");
---
> public class CIMFlavor implements Serializable {
102,110c74,132
< 	flavor=iflavor;
<     }
<      
<     // getFlavor 
<     //
<     // Returns a CIMFlavor object
<     //
<     public static CIMFlavor getFlavor(int iflavor) {
< 	int i;
---
> 	// overridable
> 	public static final int ENABLEOVERRIDE 	= 	0;
> 	//  not overridable
> 	public static final int DISABLEOVERRIDE = 	1;
> 	//inherited by subclass
> 	public static final int TOSUBCLASS 		=	2;
> 	//  only applies to the class it is declared to
> 	public static final int RESTRICTED 		= 	3;
> 	//can be specified in multiple locale
> 	public static final int TRANSLATE 	= 	4;
> 
> 
> 	private int flavor;
> 
> 	private static CIMFlavor[]  cimFlavors = new CIMFlavor[5];
> 	static {
> 		cimFlavors[0]= new CIMFlavor(ENABLEOVERRIDE);
> 		cimFlavors[1]= new CIMFlavor(DISABLEOVERRIDE);
> 		cimFlavors[2]= new CIMFlavor(TOSUBCLASS);
> 		cimFlavors[3]= new CIMFlavor(RESTRICTED);
> 		cimFlavors[4]= new CIMFlavor(TRANSLATE);
> 	}
> 
> 	/**
> 	 *	constructor
> 	 */
> 
> 	public CIMFlavor(int flavor){
> 		if( !isValidFlavor( flavor) ) {
> 			throw new IllegalArgumentException();
> 		} else {
> 			this.flavor = flavor;
> 		}
> 
> 	}
> 
> 
> 	/**
> 	 *	return the CIMFalvor
> 	 */
> 	 public static CIMFlavor getFlavor(int flavor){
> 	 	if ( (flavor < CIMFlavor.ENABLEOVERRIDE) ||
> 				(flavor > CIMFlavor.TRANSLATE)){
> 			throw new IllegalArgumentException();
> 		}
> 		return CIMFlavor.cimFlavors[flavor];
> 	 }
> 
> 	 /**
> 	  *	returns flavor 
> 	  */
> 
> 	 public int getFlavor(){
> 	 	return this.flavor;
> 	 }
> 
> 
> 
> 
112,114c134,146
< 	for(i=0;i<predefined.length;i++) {
< 	    if (predefined[i].flavor==iflavor)
< 		return(predefined[i]);
---
> 	/**
> 	 *  checks if flavor is a valid flavor 
> 	 */
> 
> 	private  boolean isValidFlavor(int flavor){
> 
> 		if (( flavor < ENABLEOVERRIDE ) || 
> 				(	flavor > TRANSLATE)) {
> 			return false;
> 		} else {
> 			return true;
> 		}
> 
116,125c148
< 	return(null);
<     }
<  
<     // getFlavor 
<     //
<     // Returns the qualifier flavor as an integer
<     //
<     public int getFlavor() {
< 	return(flavor);
<     }
---
> 		
127,135c150,162
<     // 
<     // equals
<     //
<     // Returns true if object is a valid CIM flavor
<     public boolean equals(Object o) {
< 	return (o instanceof CIMFlavor &&
< 	    ((CIMFlavor)o).flavor==flavor );
<     }
<  
---
> 
> 	/**
> 	 *	compares two CIMFlavor objects
> 	 */
> 	public boolean equals(Object obj) {
> 		if (!( obj instanceof CIMFlavor))
> 			return false;
> 
> 			CIMFlavor cf = (CIMFlavor)obj;
> 			return	(( (CIMFlavor)obj ).flavor == flavor);
> 	}
> 
> 
142,157c169,184
<     // toMOF 
<     public String toMOF() {
< 	if (flavor==ENABLEOVERRIDE)
< 	    return("ENABLEOVERRIDE");
< 	if (flavor==DISABLEOVERRIDE)
< 	    return("DISABLEOVERRIDE");
< 	if (flavor==RESTRICTED)
< 	    return("RESTRICTED");
< 	if (flavor==TOSUBCLASS)
< 	    return("TOSUBCLASS");
< 	if (flavor==RESTRICTED)
< 	    return("RESTRICTED");
< 	if (flavor==TRANSLATE)
< 	    return("TRANSLATE");
< 	return("BAD FLAVOR");
<     }
---
> 	  // toMOF 
> 	  public String toMOF() {
> 	      if (flavor==ENABLEOVERRIDE)
> 			  	return("ENABLEOVERRIDE");
> 			if (flavor==DISABLEOVERRIDE)
> 				return("DISABLEOVERRIDE"); 
> 			if (flavor==RESTRICTED) 
> 				return("RESTRICTED"); 
> 			if (flavor==TOSUBCLASS)
> 				return("TOSUBCLASS"); 
> 			if (flavor==RESTRICTED)
> 				return("RESTRICTED"); 
> 			if (flavor==TRANSLATE)
> 				return("TRANSLATE"); 
> 			return("BAD FLAVOR");
> 		}	
159c186,188
<     // toXml 
---
> 
> 	// toXml 
> 
161,162c190,191
< 	if (flavor==ENABLEOVERRIDE)
< 	    return("OVERRIDABLE");
---
> 		if (flavor==ENABLEOVERRIDE)
> 	    	return("OVERRIDABLE");
178c207
< } 
---
> }
