0a1,4
> /*
> static char sccsid[] = "@(#)81  1.1  src/com/ibm/cim/CIMMethod.java, cimom, ICAT1, ICAT1_1.0.0.7 10/10/02 14:42:16";
> */
> 
60d63
< package org.snia.wbem.cim;
62c65,67
< import java.net.MalformedURLException;
---
> 
> package com.ibm.cim;
> 
64c69,70
< import org.snia.wbemcmd.xml.*;
---
> import java.net.MalformedURLException;
> import com.ibm.xml.*;;
66,82d71
< public class CIMMethod extends CIMElement implements Cloneable {
<     static private String noOriginClass="";
<     //
<     // If you add to these, you need to fix the clone() method!
<     //
<     CIMDataType returnDatatype=null;
<     Vector qualifiers=new Vector();
<     Vector parameters=new Vector();
<     String originClass=noOriginClass;
<     String override=null;
<     boolean propagated=false;		    // true if method is inheirited
<     
<     
<     // CIMMethod
<     //
<     public CIMMethod() {
<     }
83a73
> public class CIMMethod extends CIMElement implements Cloneable{
84a75,98
> 	private	CIMDataType 	returnDatatype;
> 	private	Vector 			mQualifiers = null;
> 	private	Vector			mParameters = null;
> 	private	String			originClass = "";
> 	private	String			override = "";
> 	private	boolean			propagated = false;
> 
> 	public CIMMethod(){
> 		returnDatatype = null;
> 		mQualifiers = new Vector();
> 		mParameters = new Vector();
> 		originClass = "";
> 	}
> 
> 	public CIMMethod (String name){
> 		super(name);
> 		returnDatatype = null;
> 		mQualifiers = new Vector();
> 		mParameters = new Vector();
> 		originClass = "";
> 		
> 	}
> 
>   //
87,95d100
<     // Creates a method with a name
<     //
<     public CIMMethod(String name) {
< 	setName(name);
<     }
<  
<     //
<     // CIMMethod
<     //
101a107,110
> 	returnDatatype = null;
> 	mQualifiers = new Vector();
> 	mParameters = new Vector();
> 	originClass = "";
118,119c127
< 		throw new CIMException(CIMException.CIM_ERR_INVALID_PARAMETER,
< 		    "No method name");
---
> 		throw new CIMException(CIMException.CIM_ERR_NO_METHOD_NAME);
141c149
< 		qualifiers.addElement(new CIMQualifier(nextchild));
---
> 		mQualifiers.addElement(new CIMQualifier(nextchild));
152c160
< 		    parameters.addElement(new CIMParameter(nextchild));
---
> 		    mParameters.addElement(new CIMParameter(nextchild));
162,169d169
<     
<     // setQualifiers
<     //
<     // Sets the qualifiers for this method
<     //
<     public void setQualifiers(Vector inQual) {
< 	qualifiers=inQual;
<     }
171,177d170
<     // getQualifiers
<     //
<     // Returns the qualifiers
<     //
<     public Vector getQualifiers() {
< 	return(qualifiers);
<     }
178a172,177
> 	/**
> 	 *	returns Overriding  method name
> 	 */
> 	public String getOverridingMethod(){
> 		return this.override;
> 	}
180,191c179,185
<     // getQualifier
<     //
<     // Gets the named qualifier or null if not defined
<     //
<     public CIMQualifier getQualifier(String name){
< 	int i;
< 	int tsize=qualifiers.size();
< 	for(i=0;i<tsize;i++) {
< 	    CIMQualifier nq=((CIMQualifier)(qualifiers.elementAt(i)));
< 	    if (nq.getName().equalsIgnoreCase(name)) {
< 		return((CIMQualifier)(qualifiers.elementAt(i)));
< 	    }  
---
> 
> 
> 	/**
> 	 *	Sets Overriding  method name
> 	 */
> 	public void setOverridingMethod(String methName){
> 		this.override = methName;
193,194d186
< 	return(null);
<     }
196,202d187
<     // getOriginClass
<     // 
<     // Returns the class which defined the method
<     //
<     public String getOriginClass(){
< 	return(originClass);
<     } 
204,211c189,194
<     // setOriginClass
<     //
<     // Sets class that defined this method 
<     //
<     public void setOriginClass(String ioriginClass) {
< 	originClass=ioriginClass;
<     }
<  
---
> 	/**
> 	 *	returns Original Class of  the method
> 	 */
> 	public String getOriginClass(){
> 		return this.originClass;
> 	}
214,237c197,206
<     // setParameters
<     //
<     // Sets the list of parameters for the method
<     //
<     public void setParameters(Vector inParam) {
< 	parameters=inParam;
<     }
<  
<     // getParameters
<     //
<     // Returns the parameters 
<     //
<     public Vector getParameters() {
< 	return(parameters);
<     }
<  
<  
<     // setType
<     //
<     // Sets the return type of the method
<     //
<     public void setType(CIMDataType type) {
< 	returnDatatype=type;
<     }
---
> 	/**
> 	 *	sets  Corigna Class of the method
> 	 */
> 	public void setOriginClass(String oClass){
> 		if(oClass != null){
> 			this.originClass = oClass;
> 		}else{
> 			this.originClass = "";
> 		}
> 	}
239,254c208
<     // getType
<     //
<     // Returns the return type 
<     //
<     public CIMDataType getType() {
< 	return(returnDatatype);
<     }
<  
<  
<     // getSize
<     //
<     // Returns the size of return data type
<     //
<     public int getSize() {
< 	return(returnDatatype.getSize());
<     }
---
> 	
256,262c210,215
<     // setSize
<     //
<     // Sets size of return type
<     //
<     //public void setSize(int size) {
<     // SUNDIFF: not supported - doesn't the data type do it for us?
<     //}
---
> 	/**
> 	 *	return method  Qualifiers
> 	 */
> 	public Vector getQualifiers(){
> 		return this.mQualifiers;
> 	}
266,272d218
<     // setOverridingMethod
<     //
<     // Sets name for override
<     //
<     public void setOverridingMethod(String om) {
< 	override=om;
<     }
274,278c220,241
<     // getOverridingMethod
<     //
<     public String getOverridingMethod() {
< 	return(override);
<     }
---
> 	/**
> 	 *	return method  Qualifier 
> 	 */
> 	public CIMQualifier getQualifier(String qualName){
> 		if (mQualifiers != null) {
> 			int size = mQualifiers.size();
> 			for(int i=0;i<size;i++){
> 				CIMQualifier cimQual = (CIMQualifier) mQualifiers.elementAt(i);
> 				if( (qualName).equalsIgnoreCase(cimQual.getName())) {
> 					return cimQual;
> 				}
> 			}
> 		}	
> 		return null;
> 	}	
> 		
> 	/**
> 	 *	sets method  Qualifiers
> 	 */
> 	public void setQualifiers(Vector qualifiers){
> 		this.mQualifiers = qualifiers;
> 	}
280,283d242
<     // toString
<     public String toString() {
< 	return("CIMMethod NAME="+getName());
<     }
286c245,301
<     // toMOF
---
> 	/**
> 	 *	returns method parameters
> 	 */
> 	public Vector getParameters(){
> 		return this.mParameters;
> 	}
> 
> 	/**
> 	 *	sets method parameters
> 	 */
> 	public void setParameters( Vector parameters){
> 		this.mParameters = parameters;
> 		if (this.mParameters == null) {
> 			this.mParameters = new Vector();
> 		}
> 	}
> 
> 	/**
> 	 *	returns methods return datatype
> 	 */
> 	public CIMDataType getType(){
> 		return this.returnDatatype;
> 	}
> 
> 	/**
> 	 *	Sets methods return datatype
> 	 */
> 	public void setType(CIMDataType type){
> 		returnDatatype = type;
> 	}
> 
> 	public boolean getPropagated() {
> 		return propagated;
> 	}
> 		
> 
> 	public void setPropagated(boolean prop) {
> 		 propagated = prop;
> 	}
> 
> 	/**
> 	 *	returns clone object of cimMethod
> 	 */
> 	public Object clone() {
> 		CIMMethod cimMeth  = new CIMMethod();
> 		cimMeth.name = this.name;
> 		cimMeth.mQualifiers= this.mQualifiers;
> 		cimMeth.mParameters= this.mParameters;
> 		cimMeth.propagated= this.propagated;
> 		cimMeth.override= this.override;
> 		cimMeth.returnDatatype= this.returnDatatype;
> 
> 
> 		return cimMeth;
> 	}
> 
>  // toMOF
292c307
< 	if (qualifiers.size()>0) {
---
> 	if (mQualifiers.size()>0) {
294,295c309,310
< 	    for(i=0;i<qualifiers.size();i++) {
< 		CIMQualifier nq=((CIMQualifier)(qualifiers.elementAt(i)));
---
> 	    for(i=0;i<mQualifiers.size();i++) {
> 		CIMQualifier nq=((CIMQualifier)(mQualifiers.elementAt(i)));
309,311c324,326
< 	if (parameters.size()>0) {
< 	    for(i=0;i<parameters.size();i++) {
< 		CIMParameter nq=((CIMParameter)(parameters.elementAt(i)));
---
> 	if (mParameters.size()>0) {
> 	    for(i=0;i<mParameters.size();i++) {
> 		CIMParameter nq=((CIMParameter)(mParameters.elementAt(i)));
321,367c336
<     // clone
<     //
<     public Object clone() {
<        CIMMethod meth=new CIMMethod();
< 	meth.returnDatatype=returnDatatype;
< 	//
< 	// Qualifiers have values that change so dup them
< 	//
< 	Vector v=new Vector();
< 	for(int j=0;j<qualifiers.size();j++) {
< 	    CIMQualifier qual=(CIMQualifier)(qualifiers.elementAt(j));
< 	    v.addElement(qual.clone());
< 	}
< 	meth.setName(getName());
< 	meth.qualifiers=v;
< 	meth.parameters=parameters;
< 	meth.originClass=originClass;
< 	meth.propagated=propagated;
< 	return(meth);
<     }
<     
<     public Object clone(boolean includeQualifier,
< 				  boolean includeClassOrigin) {
< 	CIMMethod meth=new CIMMethod();
< 	meth.returnDatatype=returnDatatype;
< 	//
< 	// Qualifiers have values that change so dup them
< 	//
< 	//
< 	// Only things that can get changed on a per instance
< 	// basis get fully dup'd, the rest is just by reference
< 	//
< 	if (includeQualifier) {
< 	    meth.qualifiers=new Vector();
< 	    for(int i=0;i<qualifiers.size();i++) {
< 		CIMQualifier cq=(CIMQualifier)(qualifiers.elementAt(i));
< 		meth.qualifiers.addElement(cq.clone());
< 	    }
< 	}
< 	meth.parameters=parameters;
< 	meth.originClass=originClass;
< 	meth.propagated=propagated;
< 	return(meth);
<     }
<     
< 
<     //toXml
---
> 	 //toXml
389a359
> 
395c365,366
< 	
---
> 
> 
405a377
> 
407,409c379,381
< 	if (includeQualifiers && qualifiers!=null) {
< 	    for(int i=0;i<qualifiers.size();i++) {
< 		CIMQualifier qual=(CIMQualifier)(qualifiers.elementAt(i));
---
> 	if (includeQualifiers && mQualifiers!=null) {
> 	    for(int i=0;i<mQualifiers.size();i++) {
> 		CIMQualifier qual=(CIMQualifier)(mQualifiers.elementAt(i));
414,415c386
< 	for(int j=0;j<parameters.size();j++)
< 	    text=text.append( ((CIMParameter)(parameters.elementAt(j))).toXml());
---
> 	if (mParameters != null) {
416a388,395
> 		CIMParameter cp;
> 		for(int j=0;j<mParameters.size();j++) {
> 	    		cp = (CIMParameter)mParameters.elementAt(j);
> 	    		text = text.append(cp.toXml());
> 		}
> 
> 	}
> 
418,421d396
< 	
< 	return(text.toString());
<     }
<     
422a398
> 	String result = text.toString();
424,430c400
<     
<     public void setPropagated(boolean value) {
< 	propagated=value;
<     }
<     
<     public boolean getPropagated() {
< 	return(propagated);
---
> 	return(result);
