0a1,5
> /*
> static char sccsid[] = "@(#)86  1.1  src/com/ibm/http/HTTPInput.java, cimom, ICAT1, ICAT1_1.0.0.7 10/10/02 14:43:40";
> */
> 
> //OK
62c67
< package org.snia.wbemcmd.xml;
---
> package com.ibm.http;
68,75c73,74
< import org.snia.wbem.cim.CIMException;
< import org.snia.wbem.cim.CIMObjectPath;
< import org.snia.wbem.cim.CIMNameSpace;
< import org.snia.wbem.client.CIMOMHandle;
< import org.snia.wbemcmd.utils.Log;
< import org.snia.wbemcmd.cimom.CIMOMHandleLocal;
< import org.snia.wbemcmd.cimom.CIMOMHandleXML;
< import org.snia.wbemcfg.GlobalConfig;
---
> import com.ibm.xml.*;
> import com.ibm.http.*;
77,81d75
< /**
<  * Handles xmlCIM input requests over HTTP for the server. This class
<  * accepts HTTP socket connections and spawns a new HTTPConnection thread
<  * for each HTTP client.
<  */
83,93d76
<     /**
<        This is the count of the current number of threads running.
<        It is used in checking against the maximum number allowed.
<      */
<     private static int     numberOfThreads     =0;
<      /**
<        This is used to synchronize access to the numberOfThreads.
<      */
<     private static Integer threadSync          = new Integer(1);
<     private int port;
<         private String hostName;
94a78
> 	private HTTPWriter out;
96,227c80,81
<     // HTTPInput
<     public HTTPInput( int iport) {
<         port = iport;
<         try {
<             hostName=InetAddress.getLocalHost().getHostName();
<         } catch ( IOException e ) {
<             throw new  ExceptionInInitializerError("Could not get system name");
<         }
< 
< 
<     }
< 
<     //
<     // Input loop
<     //
<     public void process()
<     {
< 
< 
<         ServerSocket serverSocket=null;
<         try  {
< 	    // use SocketProvider to obtain a new server socket
< 	    serverSocket =
< 		SocketProvider.getProvider().createServerSocket(port,1000);
<             serverSocket.setSoTimeout(50000);
<         }
<         catch(java.net.BindException e)
<         {
< 			System.err.println("Port "+port+" is already used by some other process. \nPlease start the cimom at some other port.");
< 			System.exit(0);
< 
< 		}
< 		catch ( IOException e )
< 		{
<             Log.println( "socket create failed, exception="+e );
<             return;
<         }
< 
<         try {
<             while ( true ) {
<                 try {
<                     Socket socket = serverSocket.accept();
<                     HTTPConnection con=new HTTPConnection();
<                     con.processInputStream( socket );
<                 } catch ( InterruptedIOException e) {
<                 }
<             }
<         }
<         catch ( IOException e ) {
<             Log.println( "accept failed, exception="+e );
<         }
<     }
< 
< 
< 
< 
< 
< private class HTTPConnection implements Runnable {
<     private HTTPReader reader;
<     private InputStream    in;
<     private HTTPWriter     out;
<     private boolean intrinsic=true;
<     private String functionName;
<     private String messageId;
< 
<     //
<     // HTTPConnection
<     //
<     public HTTPConnection()
<     {
<     }
< 
< 
<     private void processInputStream(Socket socket ) {
<         try {
<             reader=new HTTPReader(socket,hostName,port);
<             in =socket.getInputStream();
<             out = new HTTPWriter(socket.getOutputStream(),hostName);
<         } catch ( IOException e ) {
<             // Connection has dropped, so quit out and try and accept() a new
<             // Call
<         }
< 
< 
<         //
<         // If threads are enabled, fork one now to handle the request
<         //
<         if (GlobalConfig.useThreads) {
< 	    while(true) {
< 		synchronized (threadSync) {
< 		    if (numberOfThreads<GlobalConfig.maxThreadCounter) {
< 			numberOfThreads++;
< 			break;
< 		    }
< 		}
< 		//
< 		// Wait till thread becomes available by polling
< 		//
< 		try {
< 		    Thread.sleep(2000);
< 		} catch (Exception e) {}
<             }
<             Thread thread = new Thread( this );
<             thread.start();
<         } else
<             run();
<     }
< 
<     // QW 427    Add inner class to handle Security/ThreadBinding
<     public class innerBinder implements java.lang.Runnable {
< 	private XMLNode node;
< 	HTTPWriter out;
<        boolean intrinsic;
<        String messageId;
<        String functionName;
< 	innerBinder(XMLNode n,
< 	            HTTPWriter o,
<                    boolean intr,
<                    String msgId,
<                    String fName) {
< 	    node=n;
< 	    out=o;
< 	    intrinsic=intr;
<            messageId=msgId;
< 	    functionName=fName;
< 	};
< 	public void run() {
< 	    try {
< 		executeXML(node,out,intrinsic,messageId,functionName);
< 	    } catch (IOException e) {
< 		Log.println( "Failed to executeXML, IO error="+e.getMessage());
< 	    }
---
> 	public HTTPInput(HTTPWriter out) {
> 		this.out = out;
229d82
<     }
231,332c84,90
<     public void run( ) {
<         boolean doflush;
< 
<         Vector returnHeaders=new Vector();
<         try {
<             for(;;) {
<                 XMLNode node;
<                 int errcode=HTTPWriter.SC_BAD_REQUEST;
<                 try {
<                     returnHeaders=new Vector();
<                     node=reader.parseRequest(returnHeaders,false);
<                     if (GlobalConfig.DEBUG_XML)
<                         Log.printlnTransaction("request parsed");
<                     if (reader.isHTTP11Request())
<                         out.setUseHTTP11ForResponse(true);
<                     else
<                         out.setUseHTTP11ForResponse(false);
<                 } catch (HTTPException he) {
<                     doflush=false;
<                     if (GlobalConfig.DEBUG_XML)
<                         Log.printlnTransaction("http exception:"+he);
<                     if (he.getId().equals(HTTPException.HTTP_ERR_OPTIONSREQUESTED)) {
<                             //
<                             // Not an error! The caller asked for options...
<                             //
<                       if (GlobalConfig.DEBUG_XML)
<                         {
<                           Log.printlnTransaction(
<                                         "Return OpenCIMOM supported OPTIONS" );
<                         }
<                       // Output options to HTTP header
<                       out.addOption("CIMValidation: " +
<                                     SUPPORTED_CIM_VALIDATION);
<                       out.addOption("CIMSupportedFunctionalGroups: "+
<                                     SUPPORTED_CIM_FUNCTIONAL_GROUPS );
<                       doflush=true;
<                     }
<                     if (he.getId().equals(HTTPException.HTTP_ERR_AUTHENTICATE)) {
<                         doflush=false;  // suppress trailing msg response
<                         for(int i=0;i<returnHeaders.size();i++) {
<                                 String hdr=(String)(returnHeaders.elementAt(i));
<                                 out.addOption(hdr);
<                                 out.sendError(HTTPWriter.SC_UNAUTHORIZED);
<                         }
<                     }
<                     if (doflush) {
<                         try {
<                             out.flush();
<                         } catch (HTTPException ce) {
<                             Log.println("Failed to write results, exception="+ce.toString());
<                         }
<                         if (reader.isForceClose()) {
<                             out.close();
<                             throw new InterruptedIOException("connection terminated");
<                         }
<                         continue;
<                     }
<                     node=null;
<                     errcode=he.getErrorCode();
<                 }
<                 if (node!=null) {
< 		    // QW 427  run it with the binding of Subject/Permission if
< 		    //        the autorizer supports it
< 		    if (GlobalConfig.requireAuthorization &&
< 			reader.getAuthorizer().accessCheckEnabled())
< 			reader.getAuthorizer().
< 			    executeChecked(new innerBinder(node,out,intrinsic,
< 							   messageId,
< 							   functionName));
< 		    else 		// no access control.
<                     executeXML(node,out,intrinsic,messageId,functionName);
<                 } else
<                     Log.println( "Failed to parse input, error="+errcode);
<                 if (GlobalConfig.forceYield)
<                     Thread.yield();
<                 if (reader.isForceClose()|| GlobalConfig.disconnectAfterTransfer ||
<                     !GlobalConfig.useContentLength ){
<                     out.close();
<                     throw new InterruptedIOException("connection terminated");
<                 }
<             }
<         }
<         catch ( IOException e ) {
<           // Connection has dropped, so quit out and try and accept() a new
<           // Call
<           if (out!=null) {
<             out.close();
<           }
<           try {
<             if (reader!=null) {
<               reader.close();
<             }
<           } catch (Exception ee) {};
<         }
<         finally {
<           synchronized (threadSync) {
<             numberOfThreads--;
<           }
<         }
<     }
< 
<     }
---
> 	public void runXML(XMLNode node) throws IOException {
> 		boolean intrinsic = true;
> 		String messageId = null;
> 		String functionName = null;
> 			
> 		executeXML(node, out, intrinsic, messageId, functionName);
> 	}
