sqlcount = 24

##########################################################################
# NOTE: THIS FILE IS NOT EXECUTED DURING INSTALLS. IT IS ONLY USED
#       DURING UPGRADES OF NON-UDB REPOSITORIES. THE LOGIC THAT BYPASSES
#       THIS SCRIPT CAN BE FOUND IN AlterFileList.java (INSTALL PACKAGE)
#
# Non dbms specific repository update script. 
# Processed by TrelliSoft.install.RepositoryAlter
# 
# This file must have the following format:
# 1) The first line of the file must contain a count of the sql stmts
#    included in the line. This info is used to update a progress bar
#    as the sql file is being processed. This line should be in the
#    format:
#        sqlcount = <n>
#    where <n> represents the # of statements contained in the file
#
# 2) Each sql statement must be terminated by a ';' as the first char
#    of a new line. Everything else on the terminator line is ignored.
#
# 3) Comments are denoted by a '#' as the first char of a line. Everything
#    on a comment line is ignored
#
# Parameter Values (see TrelliSoft.install.RepositoryInstall for all DBs):
#
# Parm    Oracle Value        MSSQL Value
# ----    ------------        ----------------------------------------------
# {0}     decimal(10)         integer
# {1}     decimal(5)          smallint
# {2}     raw(20)             varbinary(20)
# {3}     date                datetime
# {4}     long                text    
# {5}     long raw            image   
# {6}     <empty>             case_mask varbinary(8) default 0x00 not null,
# {7}     <empty>             case_mask varbinary(64) default 0x00 not null,
# {8}     sysdate             current_timestamp
# {9}     '20'                ' '
# {10}    <empty>             , case_mask
# {11}    <empty>             0x00,
# {12}    float               float
# {13}    raw(60)             varbinary(60)
# {14}    <empty>             t_res_stat_dir.
# {15}    modify              alter column 
# {16}    <empty>             <empty> (interbase: type)
# {17}    <empty>             not null
###########################################################################


alter table t_stat_fs_hist
     {15}  file_count          {16} decimal(18) {17}
;

alter table t_stat_user_hist
     {15}  file_count          {16} decimal(18) {17}
;

alter table t_stat_group_hist
     {15}  file_count          {16} decimal(18) {17}
;

alter table t_stat_space_hist
     {15}  file_count          {16} decimal(18) {17}
;

alter table t_stat_time_hist
     {15}  range1_count        {16} decimal(18) {17}
;

alter table t_stat_time_hist
     {15}  range1_size         {16} decimal(18) {17}
;

alter table t_stat_time_hist
     {15}  range2_count        {16} decimal(18) {17}
;

alter table t_stat_time_hist
     {15}  range2_size         {16} decimal(18) {17}
;

alter table t_stat_time_hist
     {15}  range3_count        {16} decimal(18) {17}
;

alter table t_stat_time_hist
     {15}  range3_size         {16} decimal(18) {17}
;

alter table t_stat_time_hist
     {15}  range4_count        {16} decimal(18) {17}
;

alter table t_stat_time_hist
     {15}  range4_size         {16} decimal(18) {17}
;

alter table t_stat_time_hist
     {15}  range5_count        {16} decimal(18) {17}
;

alter table t_stat_time_hist
     {15}  range5_size         {16} decimal(18) {17}
;

alter table t_stat_time_hist
     {15}  range6_count        {16} decimal(18) {17}
;

alter table t_stat_time_hist
     {15}  range6_size         {16} decimal(18) {17}
;

alter table t_stat_time_hist
     {15}  range7_count        {16} decimal(18) {17}
;

alter table t_stat_time_hist
     {15}  range7_size         {16} decimal(18) {17}
;

alter table t_stat_time_hist
     {15}  range8_count        {16} decimal(18) {17}
;

alter table t_stat_time_hist
     {15}  range8_size         {16} decimal(18) {17}
;

alter table t_stat_time_hist
     {15}  range9_count        {16} decimal(18) {17}
;

alter table t_stat_time_hist
     {15}  range9_size         {16} decimal(18) {17}
;

alter table t_stat_time_hist
     {15}  range10_count       {16} decimal(18) {17}
;

alter table t_stat_time_hist
     {15}  range10_size        {16} decimal(18) {17}
;

