0a1,4
> /*
> static char sccsid[] = "@(#)90  1.1  src/com/ibm/cim/CIMQualifier.java, cimom, ICAT1, ICAT1_1.0.0.7 10/10/02 14:42:24";
> */
> 
66d69
< package org.snia.wbem.cim;
67a71,73
> package com.ibm.cim;
> 
> 
70,71c76
< import java.io.Serializable;
< import org.snia.wbemcmd.xml.*;
---
> import com.ibm.xml.*;
73,76c78
< public class CIMQualifier extends CIMElement implements Serializable, Cloneable {
<     
<     static public String CIM_QUAL_KEY="key";		    // NOT SUN
<     static public String CIM_QUAL_OVERRIDE="override";     // NOT SUN
---
> public class CIMQualifier extends CIMElement {
78,87d79
<     //
<     // If you add to these, you must fix clone!
<     //
<     private CIMValue qualifierValue=null;
<     private CIMQualifierType qualifierType=null;
<     private boolean propagated=false;
<     private Vector flavor=null; 	// A vector of CIMFlavor
<     
<     public CIMQualifier() {
<     }
89,95c81
<     //
<     // CIMQualifier
<     //
<     // Creates a qualifier with the specified name
<     public CIMQualifier(String iname) {
< 	setName(iname);
<     }
---
> 	private CIMValue qualifierValue = null;
97,106c83
<     //
<     // CIMQualifier
<     //
<     // Creates a qualifier with the specified name and type
<     //
<     public CIMQualifier(String iname,
< 		     CIMQualifierType cgt) {
< 	setName(iname);
< 	qualifierType=cgt;
<     }
---
> 	private CIMQualifierType qualifierType = null;
107a85
> 	private Vector flavors = null;
108a87
> 	private boolean propagated = false;
109a89,90
>       static public String CIM_QUAL_KEY="key";		   
>       static public String CIM_QUAL_OVERRIDE="override";     
111,112c92,113
<   
<     //
---
> 
> 	//constructor
> 	public CIMQualifier() {
> 		flavors = new Vector();  
> 	}
> 
> 	//constructor
> 	public CIMQualifier(String name) {
> 		super(name);
> 		flavors = new Vector();
> 	}
> 
> 
> 	//constructor
> 	public CIMQualifier(String name, CIMQualifierType qualType) {
> 		super(name);
> 		qualifierType = qualType;
> 		flavors = new Vector();
> 	}
> 
> 
>  //
123c124,126
< 	    
---
> 	flavors = new Vector();   
> 	
> 
142c145,146
< 		throw new CIMException(CIMException.CIM_ERR_FAILED,"Qualifer not assigned a type");
---
> //		throw new CIMException(CIMException.CIM_ERR_INVALID_QUALIFIER_DATATYPE);
> 		dt = new CIMDataType(CIMDataType.STRING);
145,146c149
< 		new CIMException(CIMException.CIM_ERR_FAILED,
< 				    "No type being set on qualifier "+qualName);
---
> 		new CIMException(CIMException.CIM_ERR_INVALID_QUALIFIER_DATATYPE);
197,204d199
<     
<     // getValue
<     // 
<     // Returns the value of this qualifier
<     //
<     public CIMValue getValue() {
< 	return(qualifierValue);
<     }
206,210c201,206
<     // setValue
<     //
<     public void setValue(CIMValue value) {
< 	qualifierValue=value;
<     }
---
> 	/**
> 	 *	Returns value of Qualifier
> 	 */
> 	public CIMValue getValue() {
> 		return this.qualifierValue;
> 	}	
211a208,213
> 	/**
> 	 *	Returns value of Qualifier
> 	 */
> 	public void setValue(CIMValue val) {
> 		qualifierValue = val;
> 	}	
213,217d214
<     // setDefaults
<     //
<     public void setDefaults(CIMQualifierType cqt) {
< 	qualifierType=cqt;
<     }
219,232c216,221
<     // Returns TRUE if the qualifier has specified flavor
<     public boolean hasFlavor(CIMFlavor iflavor) {
< 	int i;
< 	
< 	if (flavor==null)
< 	    return(false);
< 	
< 	int tsize=flavor.size();
< 	for(i=0;i<tsize;i++)
< 	    if (((CIMFlavor)flavor.elementAt(i)).getFlavor()==iflavor.getFlavor())
< 		return(true);
< 	
< 	return(false);
<     }
---
> 	/**
> 	 *	Returns value of Qualifier
> 	 */
> 	public void setDefaults(CIMQualifierType qType) {
> 		qualifierType = qType;
> 	}	
235,257c224,229
<     // addFlavor
<     //
<     // SUNDIFF: SUN's API adds the flavor and verifies no conflict
<     // but there is no way of reporting back any conflicts - this version
<     // does no verification
<     //
<     public void addFlavor(CIMFlavor newFlavor) {
< 	int i;
< 	//
< 	// Check the vector has been created
< 	//
< 	if (flavor==null)
< 	    flavor=new Vector();
< 	//
< 	// Don't add it if its already present
< 	//
< 	int tsize=flavor.size();
< 	for(i=0;i<tsize;i++)
< 	    if (((CIMFlavor)flavor.elementAt(i)).getFlavor()==newFlavor.getFlavor())
< 		return;
< 	
< 	flavor.addElement(newFlavor);	
<     }
---
> 	/**
> 	 *	Returns true if Qualifier is propogated
> 	 */
> 	public boolean getPropagated() {
> 		return propagated;
> 	}	
259,262d230
<     // toString
<     public String toString() {
< 	return("CIMQualifer("+getName()+")");
<     }
264c232,320
<     //toMOF
---
> 	/**
> 	 *	Sets propogated variable
> 	 */
> 	public void setPropagated(boolean p) {
> 		propagated = p;
> 	}	
> 
> 
> 	/**
> 	 *	Returns  Vector of flavor
> 	 */
> 	public Vector getFlavor() {
> 		return flavors;
> 	}	
> 
> 	/**
> 	 *	Returns true if Qualifier has value 
> 	 */
> 	public boolean hasValue() {
> 		if(qualifierValue != null) 
> 			return true;
> 		else	
> 			return false;	
> 	}		
> 
> 	/**
> 	 *	Return if flavor is present in flavor vector
> 	 */
> 	public boolean hasFlavor(CIMFlavor cFlavor) {
> 		boolean found = false;
> 		if( cFlavor != null) {
> 			for(int i=0; i<flavors.size(); i++) {
> 				if (flavors.elementAt(i).equals(cFlavor)) {
> 					found = true;
> 				}
> 			}
> 		} 
> 		return found;
> 	}
> 
> 	/**
> 	 *	Adds CIMFlavor to vector if not present already
> 	 */
> 	public void addFlavor (CIMFlavor cFlavor) {
> 		if(! hasFlavor(cFlavor)) {
> 			flavors.addElement(cFlavor);
> 		}
> 	}	
> 
> 
> 	/**
> 	 *	Compares two qualifiers and return true if they are equal
> 	 */
> 	public boolean equals(Object obj) { 
> 		if(!(obj instanceof CIMQualifier)) {
> 			return false;
> 		} else {
> 			return	((((CIMQualifier) obj).getName()).equals(this.getName()));
> 		}
> 	}	
> 
> 
> 	/**
> 	 * clones CIMQualifier object
> 	 */
> 	public Object clone() {
> 		CIMQualifier cimQual = new CIMQualifier();
> 		cimQual.setName(getName());
> 		cimQual.propagated = this.propagated;
> 		if (qualifierValue != null) {
> 			cimQual.qualifierValue = new CIMValue(qualifierValue.getValue(),
> 													qualifierValue.getType());
> 		}
> 
> 		if(qualifierType != null) {
> 			cimQual.qualifierType = (CIMQualifierType) qualifierType.clone();
> 		}
> 
> 		if(flavors != null) {
> 			cimQual.flavors = new Vector();
> 			for (int i=0; i<flavors.size();i++) {
> 				cimQual.flavors.addElement(flavors.elementAt(i));
> 			}	
> 		}
> 		return cimQual;
> 	}
> 
> 
> //toMOF
279,331c335
<     // hasValue
<     // 
<     // Returns TRUE if the qualifier has a value set.
<     //
<     public boolean hasValue() {
<        return(qualifierValue!=null);
<     }
< 
<     // equals
<     //
<     // Returns true if this qualifier has the same name 
<     // as the passed qualifier
<     //
<     public boolean equals(Object o) {
< 	return ( (o instanceof CIMQualifier)  
< 		&& (((CIMQualifier)o).getName().equals(getName())));
<     }
< 
<     // clone
<     public Object clone() {
< 	CIMQualifier cq=new CIMQualifier();
< 
< 	if (qualifierValue!=null) 
< 	    cq.qualifierValue=new CIMValue(
< 		    qualifierValue.getValue(),
< 		    qualifierValue.getType());
< 
< 	if (qualifierType!=null)
< 	    cq.qualifierType=(CIMQualifierType)qualifierType.clone();
< 	
< 	cq.propagated=propagated;
< 	cq.setName(getName());
< 	if (flavor!=null) {
< 	    cq.flavor=new Vector();		//CIMFlavor
< 	    int tsize=flavor.size();
< 	    for(int i=0;i<tsize;i++)
< 		cq.flavor.addElement(flavor.elementAt(i));
< 	}
< 	return(cq);
<     }
< 
<     // getFlavor
<     public Vector getFlavor() {
< 	//
< 	// Check the vector has been created
< 	//
< 	if (flavor==null)
< 	    flavor=new Vector();
< 	
<       return(flavor);
<     }
<     
<     // toXml
---
>   // toXml
438,446c442
<     
<     
<     public void setPropagated(boolean value) {
< 	propagated=value;
<     }
<     
<     public boolean getPropagated() {
< 	return(propagated);
<     }
---
> 
